VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   3984
   ClientLeft      =   120
   ClientTop       =   408
   ClientWidth     =   6420
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   332
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   535
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer LoopTimer 
      Enabled         =   0   'False
      Interval        =   60
      Left            =   120
      Top             =   120
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'----------- C 
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Private Declare Function PatBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal crTransparent As Long) As Boolean


'  
Private Type MemoryDc
 DC As Long
 width As Long
 height  As Long
End Type

'      
Dim SCREENBUFFER As MemoryDc
'      
'--------------------------  

'   
Private Type CHARACTER
 SPRITE As MemoryDc
 X As Long '    X
 Y As Long '    Y
 width As Long '  
 height As Long '  
 Frame As Long '  
 SrcX As Long '  X   
 SrcY As Long '  Y   
 Action As Long ' 
End Type

'  
Dim PLAYER As CHARACTER

Private Type MAPTYPE
 BUFFER As MemoryDc
 SPRITE As MemoryDc
 BlockWidth As Long
 BlockHeight As Long
 MapArray(16, 10) As String
End Type

Dim MAP As MAPTYPE

Private Sub Form_Load()
 '    
 
'-------------------------------        2  4  . ;)
 
With MAP
 .BlockWidth = 16
 .BlockHeight = 16
 SCREENBUFFER = CreateMemoryDc(Me.hdc, UBound(.MapArray, 1) * .BlockWidth, UBound(.MapArray, 2) * .BlockHeight)
End With
width = SCREENBUFFER.width * Screen.TwipsPerPixelX * 3
height = SCREENBUFFER.height * Screen.TwipsPerPixelY * 3
 
 '     
 PLAYER.SPRITE = CreateMemoryDc(Me.hdc)
 MAP.BUFFER = CreateMemoryDc(Me.hdc, SCREENBUFFER.width, SCREENBUFFER.height)
 MAP.SPRITE = CreateMemoryDc(Me.hdc)
 ' 
 LoadSprite PLAYER.SPRITE, App.Path & "\PIC.bmp"
 LoadSprite MAP.SPRITE, App.Path & "\BG.bmp"

With PLAYER
 .width = 19
 .height = 29
 .X = SCREENBUFFER.width / 2
 .Y = SCREENBUFFER.height / 2
End With
' 
DrawMap
'  
LoopTimer = True
End Sub
Private Sub DrawPlayer()
With PLAYER

' ACTION  0.       
.Action = 0
'  
If KeyState(vbKeyUp) Then .Action = 2: .SrcX = .width * 6
If KeyState(vbKeyDown) Then .Action = 4: .SrcX = .width * 9
If KeyState(vbKeyLeft) Then .Action = 1: .SrcX = 0
If KeyState(vbKeyRight) Then .Action = 3: .SrcX = .width * 3
If KeyState(vbKeySpace) Then .Action = 5: .SrcX = .width * 12

'   1   .   SrcX
.Frame = .Frame + 1
If .Frame > 2 Then .Frame = 0

Select Case .Action
Case 1 '  
 .X = .X - 4
Case 2 '  
 .Y = .Y - 4
Case 3 '  
 .X = .X + 4
Case 4 ' 
 .Y = .Y + 4
Case Else '  
 .Frame = 0
End Select
'     (    7-01  - xSrc.   .SrcX + .Frame * .Width.      . . xSrc   , Frame        )
TransparentBlt SCREENBUFFER.DC, .X, .Y, .width, .height, PLAYER.SPRITE.DC, .SrcX + .Frame * .width, .SrcY, .width, .height, vbWhite
' Player.SrcX = Player.SrcX + Player.Width
 End With
End Sub

'---------------------------------  
Private Sub LoadSprite(MemDc As MemoryDc, PicturePath As String)
Dim Bitmap As IPictureDisp '         
'--------\  
Set Bitmap = LoadPicture(PicturePath)
'  DC
With MemDc
 '           ,     
 .width = ScaleX(Bitmap.width, 8, 3)
 .height = ScaleY(Bitmap.height, 8, 3)
 '     .      
 SelectObject .DC, Bitmap
End With
'---------\    
' 
Set Bitmap = Nothing
End Sub
Private Function CreateMemoryDc(DestDc As Long, Optional width As Long, Optional height As Long) As MemoryDc
Dim DCRECT As Long
 With CreateMemoryDc
  '     
  .DC = CreateCompatibleDC(DestDc)
  '     
   DCRECT = CreateCompatibleBitmap(DestDc, width, height)
  ' 
  SelectObject .DC, DCRECT
  '       .        
  .width = width
  .height = height
 End With
End Function

Private Sub Form_Unload(Cancel As Integer)
 ' 
 DeleteDC SCREENBUFFER.DC
 DeleteDC PLAYER.SPRITE.DC
 DeleteDC MAP.SPRITE.DC
 DeleteDC MAP.BUFFER.DC
End Sub

Sub DrawMap(Optional MapString As String)
'    
  For Y = 0 To UBound(MAP.MapArray, 2)
   For X = 0 To UBound(MAP.MapArray, 1)
    
    With MAP
     Randomize
     BitBlt MAP.BUFFER.DC, .BlockWidth * X, Y * .BlockHeight, .BlockWidth, .BlockHeight, MAP.SPRITE.DC, .BlockWidth * 2, 0, vbSrcCopy
    End With
   
   Next
  Next
End Sub
Private Sub LoopTimer_Timer()
 With SCREENBUFFER
   
  '    
  BitBlt .DC, 0, 0, .width, .height, MAP.BUFFER.DC, 0, 0, vbSrcCopy
  ' 
  DrawPlayer
  
  '  
  StretchBlt hdc, 0, 0, ScaleWidth, ScaleHeight, .DC, 0, 0, .width, .height, vbSrcCopy
 End With
End Sub
'   .
Private Function KeyState(KEYN As Long) As Boolean
If GetKeyState(KEYN) = -127 Or GetKeyState(KEYN) = -128 Then KeyState = True
End Function

